//XML RPC implementation für Fldigi
unit FlRPC_S;
{$mode objfpc}{$H+}
interface

//Fldigi XML-RPC einer Methode mit Rückgabewert als string
//MetName = Name der Methode abrfagen der Fldigi Verion => fldigi.version
//IP Addresse => konfiguriert in Fdigi
//Port => konfiguriert in Fdigi
function GetRpcSValue(MetName, Address, Port: string): string;

implementation
uses
  Classes, SysUtils, HTTPSend, Laz2_DOM, Laz2_XMLWrite;

//XML Tag parsen ===============================================================
function GetTagValue(Data, tg: string): string;
var
  EndTag: string;
  p     : word;
begin
  Result:= '';
  EndTag:= '</' + copy(tg, 2, Length(tg) - 1);
  p:= Pos(tg, Data);
  if p > 0 then
  begin
    Result:= copy(Data, p + Length(tg), Pos(EndTag, Data) - p - Length(tg));
    Result:= Trim(Result);
  end;
end;

//XML-RPC Abfrage ==============================================================
function GetRpcSValue(MetName, Address, Port: string): string;
var
  answ     : TStringList;
  http     : THTTPSend;
  XMLDoc   : TXMLDocument;
  FdRoot   : TDOMNode;
  FdMetName: TDOMNode;
  FdMetVal : TDOMNode;
begin
  //XML Doc aufbauen
  XMLDoc   := TXMLDocument.Create;// XML Dokument erzeugen
  FdRoot   := XMLDoc.CreateElement('methodCall');// Wurzelknoten erzeugen
  XMLDoc.AppendChild(FdRoot);
  FdRoot   := XMLDoc.DocumentElement;// Kind Element erzeugen
  FdMetName:= XMLDoc.CreateElement('methodName');
  FdMetVal := XMLDoc.CreateTextNode(MetName);// Wert für Kind Element
  FdMetName.AppendChild(FdMetVal);
  FdRoot.AppendChild(FdMetName);// Elemente sichern
  //XML RPC Abfrage
  answ:= TStringList.Create;
  http:= THTTPSend.Create;
  try
    WriteXML(XMLDoc, http.Document);
    if http.HTTPMethod('POST', Address +':'+ Port) then//Abfrage senden
    begin
      answ.LoadFromStream(http.Document);//Antwort abholen
      Result:= GetTagValue(answ.Text,'<value>');//Wert extrahieren
    end;
  finally
    http.Free;
    XMLDoc.Free;
    answ.Free;
  end;
end;

end.

